diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index 6d099f075..39aa080a1 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -32,6 +32,7 @@ import net.minecraft.client.gui.options.data.OptionsPages;
 import net.minecraft.client.gui.toasts.GuiElementToastsHud;
 import net.minecraft.client.holiday.Holidays;
 import net.minecraft.client.net.handler.PacketHandlerClient;
+import net.minecraft.client.render.TileEntityRenderDispatcher;
 import net.minecraft.client.render.block.model.BlockModelGrass;
 import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.font.FontRendererDefault;
@@ -74,6 +75,7 @@ import net.minecraft.core.net.command.commands.CommandTestFor;
 import net.minecraft.core.net.command.commands.CommandTime;
 import net.minecraft.core.net.command.commands.CommandWeather;
 import net.minecraft.core.net.command.util.CommandHelper;
+import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.AES;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.LoggedPrintStream;
@@ -515,14 +517,14 @@ public class Minecraft
         
         if(gameSettings.enableMultiDrawRendering.value) {
             if(OpenGLHelper.gl20) {
-            	System.out.println("Using MultiDraw terrain renderer");
+            	LOGGER.info("Using MultiDraw terrain renderer");
             	terrainRenderer = new TerrainRendererMultiDraw(this);
             }else {
-            	System.out.println("MultiDraw not supported, using legacy terrain renderer");
+            	LOGGER.info("MultiDraw not supported, using legacy terrain renderer");
             	terrainRenderer = new TerrainRendererLegacy(this);
             }
         }else {
-        	System.out.println("MultiDraw disabled, using legacy terrain renderer");
+        	LOGGER.info("MultiDraw disabled, using legacy terrain renderer");
         	terrainRenderer = new TerrainRendererLegacy(this);
         }
         
@@ -1013,7 +1015,8 @@ public class Minecraft
                     Time.tick();
                     AABB.initializePool();
                     Vec3.initializePool();
-                    
+                    NamespaceID.initializePool();
+
                     if(gameWindow.shouldClose()) shutdown();
                     if(isGamePaused && currentWorld != null && !(currentScreen instanceof ScreenModelViewer))
                     {
@@ -1194,6 +1197,7 @@ public class Minecraft
             System.gc();
             AABB.deinitializePool();
             Vec3.deinitializePool();
+            NamespaceID.deinitializePool();
         }
         catch(Throwable ignored) { }
         try
@@ -1806,13 +1810,9 @@ public class Minecraft
             if(!isGamePaused)
             {
                 worldRenderer.updateRenderer();
-            }
-            if(!isGamePaused)
-            {
                 renderGlobal.updateClouds();
-            }
-            if(!isGamePaused)
-            {
+                TileEntityRenderDispatcher.instance.tick();
+
                 Debug.change("entity");
                 if(currentWorld.lightningFlicker > 0)
                 {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenFontTest.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenFontTest.java
index 9c5823e46..75492bed0 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenFontTest.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenFontTest.java
@@ -14,7 +14,7 @@ import java.util.Map;
 
 public class ScreenFontTest extends Screen{
     private static final char[] chars = {'H', 'e', 'l', 'l', 'o', ' ', 'W', 'o', 'r', 'l', 'd', '!'};
-    private static final @NotNull NamespaceID testId = new NamespaceID("test", "value");
+    private static final @NotNull NamespaceID testId = NamespaceID.getPermanent("test", "value");
     private static final @NotNull StringBuilder builder = new StringBuilder();
     public double scroll = 0;
     public ScreenFontTest(final @Nullable Screen parent) {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenMobPicker.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenMobPicker.java
index 9fbd5a4c3..21b47a2e2 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenMobPicker.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenMobPicker.java
@@ -44,7 +44,7 @@ public class ScreenMobPicker
         List<String> prettyMonsters = new ArrayList<>();
         for (NamespaceID monster : monsters) {
             StringBuilder sb = new StringBuilder();
-            for (char c : monster.value.toCharArray()) {
+            for (char c : monster.value().toCharArray()) {
                 if (Character.isUpperCase(c)) {
                     sb.append(' ');
                 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenWandMobPicker.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenWandMobPicker.java
index 922125d27..806789c46 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenWandMobPicker.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenWandMobPicker.java
@@ -38,7 +38,7 @@ public class ScreenWandMobPicker extends Screen {
         List<String> prettyMonsters = new ArrayList<>();
         for (NamespaceID monster : monsters) {
             StringBuilder sb = new StringBuilder();
-            for (char c : monster.value.toCharArray()) {
+            for (char c : monster.value().toCharArray()) {
                 if (Character.isUpperCase(c)) {
                     sb.append(' ');
                 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobInfoRegistry.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobInfoRegistry.java
index a8d2302f6..014b8c692 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobInfoRegistry.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobInfoRegistry.java
@@ -65,6 +65,15 @@ public abstract class MobInfoRegistry {
                 new MobDrop(new ItemStack(Items.FEATHER_CHICKEN), 0.66f, 1, 2)
             }
         );
+        register(MobDeer.class,
+                "guidebook.section.mob.deer.name",
+                "guidebook.section.mob.deer.desc",
+                10,
+                10,
+                new MobDrop[] {
+                        new MobDrop(new ItemStack(Items.FOOD_VENISON_RAW), 1.0F, 1, 2)
+                }
+        );
         register(MobSquid.class,
             "guidebook.section.mob.squid.name",
             "guidebook.section.mob.squid.desc",
diff --git a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryBlock.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryBlock.java
index 26deddd45..0be3ae05f 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryBlock.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryBlock.java
@@ -245,22 +245,22 @@ public class ViewerCategoryBlock extends ModelViewerCategory<ViewerCategoryBlock
                 if (Block.hasLogicClass(block, IPainted.class)) {
                     for (DyeColor color : DyeColor.blockOrderedColors()) {
                         int newMeta = meta | ((IPainted)block.getLogic()).toMetadata(color);
-                        renderInfos.add(new BlockRenderInfo(new File(outputDir, block.namespaceId().value + "_" + color.colorID + ".png"), id, newMeta, rot, zoom));
+                        renderInfos.add(new BlockRenderInfo(new File(outputDir, block.namespaceId().value() + "_" + color.colorID + ".png"), id, newMeta, rot, zoom));
                     }
                 } else if (Block.hasLogicClass(block, BlockLogicFlowerStackable.class)) {
                     for (int i = 0; i <= BlockLogicFlowerStackable.MAX_STACK_COUNT; i++) {
-                        renderInfos.add(new BlockRenderInfo(new File(outputDir, block.namespaceId().value + "_" + i + ".png"), id, BlockLogicFlowerStackable.setStackCount(meta, i), rot, zoom));
+                        renderInfos.add(new BlockRenderInfo(new File(outputDir, block.namespaceId().value() + "_" + i + ".png"), id, BlockLogicFlowerStackable.setStackCount(meta, i), rot, zoom));
                     }
                 } else if (Block.hasLogicClass(block, BlockLogicCropsWheat.class)) {
                     for (int i = 0; i <= BlockLogicCropsWheat.MAX_GROWTH_STATE; i++) {
-                        renderInfos.add(new BlockRenderInfo(new File(outputDir, block.namespaceId().value + "_" + i + ".png"), id, meta | i, rot, zoom));
+                        renderInfos.add(new BlockRenderInfo(new File(outputDir, block.namespaceId().value() + "_" + i + ".png"), id, meta | i, rot, zoom));
                     }
                 } else if (Block.hasLogicClass(block, BlockLogicCropsPumpkin.class)) {
                     for (int i = 0; i < 5; i++) {
-                        renderInfos.add(new BlockRenderInfo(new File(outputDir, block.namespaceId().value + "_" + i + ".png"), id, meta | i, rot, zoom));
+                        renderInfos.add(new BlockRenderInfo(new File(outputDir, block.namespaceId().value() + "_" + i + ".png"), id, meta | i, rot, zoom));
                     }
                 } else {
-                    renderInfos.add(new BlockRenderInfo(new File(outputDir, block.namespaceId().value + ".png"), id, meta, rot, zoom));
+                    renderInfos.add(new BlockRenderInfo(new File(outputDir, block.namespaceId().value() + ".png"), id, meta, rot, zoom));
                 }
             }
             id = ScreenModelViewer.cycleBlockId(id, 1);
diff --git a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
index edb5f4137..d05b0c3ac 100644
--- a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -134,7 +134,7 @@ public class GameSettings {
 	public OptionBoolean alwaysShowDescriptions = new OptionBoolean(this, "alwaysShowDescriptions", false);
 	public OptionBoolean turnWithVehicle = new OptionBoolean(this, "turnWithVehicle", true);
 	public OptionBoolean disableCrashHandler = new OptionBoolean(this, "disableCrashHandler", false);
-	public OptionBoolean enableMultiDrawRendering = new OptionBoolean(this, "enableMultiDrawRendering", false);
+	public OptionBoolean enableMultiDrawRendering = new OptionBoolean(this, "enableMultiDrawRendering", true);
 
 	public OptionBoolean enableDevResourceLoading = new OptionBoolean(this, "enableDevResourceLoading", false);
 	public OptionBoolean downloadSoundfiles = new OptionBoolean(this, "downloadSoundfiles", true);
diff --git a/game/client/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java
index fdd9b2918..ca64d9f7a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java
@@ -11,11 +11,7 @@ import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.EntityLightning;
 import net.minecraft.core.entity.EntityPainting;
 import net.minecraft.core.entity.Mob;
-import net.minecraft.core.entity.animal.MobButterfly;
-import net.minecraft.core.entity.animal.MobChicken;
-import net.minecraft.core.entity.animal.MobFireflyCluster;
-import net.minecraft.core.entity.animal.MobWolf;
-import net.minecraft.core.entity.animal.MobSquid;
+import net.minecraft.core.entity.animal.*;
 import net.minecraft.core.entity.monster.*;
 import net.minecraft.core.entity.projectile.ProjectileCannonball;
 import net.minecraft.core.entity.projectile.ProjectileEgg;
@@ -35,9 +31,6 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityFishingBobber;
 import net.minecraft.core.entity.EntityFallingBlock;
 import net.minecraft.core.entity.EntityPrimedTNT;
-import net.minecraft.core.entity.animal.MobCow;
-import net.minecraft.core.entity.animal.MobPig;
-import net.minecraft.core.entity.animal.MobSheep;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.projectile.ProjectileArrow;
 import net.minecraft.core.entity.projectile.ProjectilePebble;
@@ -113,6 +106,7 @@ public final class EntityRenderDispatcher
         assignRenderer(ProjectileCannonball.class, new EntityRendererCannonball());
         assignRenderer(ProjectilePebble.class, new EntityRendererSprite<>(Items.AMMO_PEBBLE));
         assignRenderer(MobButterfly.class, new MobRendererButterfly());
+        assignRenderer(MobDeer.class, new MobRendererDeer(0.7F));
     }
 
     private <T extends Entity> void assignRenderer(final @NotNull Class<? extends T> clazz, final @NotNull EntityRenderer<T> renderer) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
index 08720bee3..c0ef84e18 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -18,6 +18,7 @@ import net.minecraft.client.render.terrain.ChunkRenderer;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tileentity.TileEntityRenderer;
 import net.minecraft.client.render.worldtype.WorldTypeFX;
 import net.minecraft.client.render.worldtype.WorldTypeFXDispatcher;
 import net.minecraft.client.world.WorldClient;
@@ -516,9 +517,9 @@ public class RenderGlobal
             }
         }
 
-        for (TileEntity tileEntity : tileEntities)
-        {
-            TileEntityRenderDispatcher.instance.renderTileEntity(tessellator, tileEntity, partialTick);
+        for (int i = 0, tileEntitiesSize = tileEntities.size(); i < tileEntitiesSize; i++) {
+            TileEntity tileEntity = tileEntities.get(i);
+            TileEntityRenderDispatcher.instance.renderTileEntity(tessellator, camera, tileEntity, partialTick);
         }
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/TextureManager.java b/game/client/src/main/java/net/minecraft/client/render/TextureManager.java
index 47fca8990..66940ee52 100644
--- a/game/client/src/main/java/net/minecraft/client/render/TextureManager.java
+++ b/game/client/src/main/java/net/minecraft/client/render/TextureManager.java
@@ -139,7 +139,7 @@ public class TextureManager {
 	}
 	protected void addDynamicTextureOverride(DynamicTexture texture, boolean override) {
 		if (!override && dynamicTextures.containsKey(texture.targetTexture.namespaceId)) return;
-		dynamicTextures.put(texture.targetTexture.namespaceId.namespace + ":" + TextureRegistry.stitcherMapReverse.get(texture.targetTexture.parentAtlas) + "/" + texture.targetTexture.namespaceId.value, texture);
+		dynamicTextures.put(texture.targetTexture.namespaceId.namespace() + ":" + TextureRegistry.stitcherMapReverse.get(texture.targetTexture.parentAtlas) + "/" + texture.targetTexture.namespaceId.value(), texture);
 	}
 
 	private void loadCustomAnimations() {
diff --git a/game/client/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java
index 7719805c6..afaff32da 100644
--- a/game/client/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java
@@ -113,27 +113,30 @@ public final class TileEntityRenderDispatcher
         this.viewLerpPosZ = camera.getZ(partialTick);
     }
 
-    public <T extends TileEntity> void renderTileEntity(final @NotNull Tessellator tessellator, final @NotNull T tileEntity, final float partialTick)
+    public <T extends TileEntity> void renderTileEntity(final @NotNull Tessellator tessellator, final ICamera camera, final @NotNull T tileEntity, final float partialTick)
     {
-        if(tileEntity.getDistanceFrom(this.viewLerpPosX, this.viewLerpPosY, this.viewLerpPosZ) < 4096D)
-        {
-            assert this.world != null;
-            final float brightness;
-            if(LightmapHelper.isLightmapEnabled()) {
-            	LightmapHelper.setLightmapCoord(this.world.getLightmapCoord(tileEntity.x, tileEntity.y, tileEntity.z, 0));
-                brightness = 1.0f;
-            }else if(Global.accessor.isFullbrightEnabled()) {
-                brightness = 1.0f;
-            }else {
-                brightness = this.world.getLightBrightness(tileEntity.x, tileEntity.y, tileEntity.z);
-            }
-            GL11.glColor3f(brightness, brightness, brightness);
-            renderTileEntity(tessellator,
-                    tileEntity,
-                    (double)tileEntity.x - renderPosX,
-                    (double)tileEntity.y - renderPosY,
-                    (double)tileEntity.z - renderPosZ, partialTick);
+        final TileEntityRenderer<T> renderer = TileEntityRenderDispatcher.instance.getRenderer(tileEntity);
+
+        if (renderer == null) return;
+        if(tileEntity.getDistanceFrom(this.viewLerpPosX, this.viewLerpPosY, this.viewLerpPosZ) > 4096D) return;
+        if (!renderer.isVisible(tileEntity, camera, partialTick)) return;
+
+        assert this.world != null;
+        final float brightness;
+        if(LightmapHelper.isLightmapEnabled()) {
+            LightmapHelper.setLightmapCoord(this.world.getLightmapCoord(tileEntity.x, tileEntity.y, tileEntity.z, 0));
+            brightness = 1.0f;
+        }else if(Global.accessor.isFullbrightEnabled()) {
+            brightness = 1.0f;
+        }else {
+            brightness = this.world.getLightBrightness(tileEntity.x, tileEntity.y, tileEntity.z);
         }
+        GL11.glColor3f(brightness, brightness, brightness);
+        renderer.doRender(tessellator,
+            tileEntity,
+            (double)tileEntity.x - renderPosX,
+            (double)tileEntity.y - renderPosY,
+            (double)tileEntity.z - renderPosZ, partialTick);
     }
 
     public <T extends TileEntity> void renderTileEntity(final @NotNull Tessellator tessellator, final @NotNull T tileEntity, final double x, final double y, final double z, final float partialTick)
@@ -145,6 +148,13 @@ public final class TileEntityRenderDispatcher
         }
     }
 
+    public void tick() {
+        for (final TileEntityRenderer<?> renderer : this.renderers.values()) {
+            if (renderer == null) continue;
+            renderer.tick();
+        }
+    }
+
     public @NotNull FontRenderer getFont()
     {
         return this.font;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFurnace.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFurnace.java
index 592b70f97..64a4a8a16 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFurnace.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFurnace.java
@@ -28,7 +28,7 @@ public class BlockModelFurnace<T extends BlockLogic>
             if (container != null) {
                 boolean hasOutput = container.getItem(2) != null;
                 if (hasOutput) {
-                    return TextureRegistry.getTexture(originalFront.namespaceId.namespace + ":block/" + originalFront.namespaceId.value + "_filled");
+                    return TextureRegistry.getTexture(originalFront.namespaceId.namespace() + ":block/" + originalFront.namespaceId.value() + "_filled");
                 }
             }
             return originalFront;
diff --git a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureFireflyJar.java b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureFireflyJar.java
index 56d171632..a975e53cc 100644
--- a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureFireflyJar.java
+++ b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureFireflyJar.java
@@ -14,7 +14,7 @@ public class DynamicTextureFireflyJar extends DynamicTexture {
         super(texture);
 		BufferedImage image = texture.getImageStorage();
 		if(image == null) {
-			throw new TexturePackException("Could not load image!");
+			throw new TexturePackException("Could not load image from texture'" + texture.namespaceId + "'!");
 		}
         texture.setDimension(image.getWidth(), image.getHeight());
         this.originalData = new byte[texture.getArea() * 4];
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererLightningBolt.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererLightningBolt.java
index e77c83682..75c6ff44a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererLightningBolt.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererLightningBolt.java
@@ -114,5 +114,6 @@ public class EntityRendererLightningBolt extends EntityRenderer<EntityLightning>
         GL11.glDisable(GL11.GL_BLEND);
         GL11.glEnable(GL11.GL_LIGHTING);
         GL11.glEnable(GL11.GL_TEXTURE_2D);
+        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererPainting.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererPainting.java
index 00cddbbf7..8814440d8 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererPainting.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererPainting.java
@@ -150,8 +150,7 @@ public class EntityRendererPainting extends EntityRenderer<EntityPainting>
             GL11.glEnable(GL11.GL_BLEND);
             GL11.glBlendFunc(770, 771);
             GL11.glColor4f(1f, 1f, 1f, 1f);
-            NamespaceID id = EntityPainting.getBorder(borderStack);
-            bindTexture(String.format("/assets/%s/textures/art/borders/%s.png", id.namespace, id.value));
+            bindTexture(EntityPainting.getBorder(borderStack));
             renderBorder(entity, entity.art.sizeX, entity.art.sizeY);
             GL11.glDisable(GL11.GL_BLEND);
         }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBipedArmored.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBipedArmored.java
index 8cc98bc95..72bc573ce 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBipedArmored.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBipedArmored.java
@@ -39,7 +39,7 @@ public abstract class MobRendererBipedArmored<T extends Mob & IArmorWearing<Huma
         } else if (item instanceof IArmorItem) {
             final IArmorItem armorItem = (IArmorItem) item;
             if (armorItem.getArmorMaterial() == null) return null;
-            bindTexture(String.format("/assets/%s/textures/armor/%s_%d.png", armorItem.getArmorMaterial().identifier.namespace, armorItem.getArmorMaterial().identifier.value, (layer != 3 ? 1 : 2)));
+            bindTexture(String.format("/assets/%s/textures/armor/%s_%d.png", armorItem.getArmorMaterial().identifier.namespace(), armorItem.getArmorMaterial().identifier.value(), (layer != 3 ? 1 : 2)));
         } else {
             return null;
         }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererDeer.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererDeer.java
new file mode 100644
index 000000000..d82bf3db4
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererDeer.java
@@ -0,0 +1,44 @@
+package net.minecraft.client.render.entity;
+
+import net.minecraft.core.entity.animal.MobDeer;
+import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.lwjgl.opengl.GL11;
+import org.useless.dragonfly.models.entity.BoneTransform;
+import org.useless.dragonfly.models.entity.StaticEntityModel;
+
+public class MobRendererDeer extends MobRenderer<MobDeer> {
+
+    public MobRendererDeer(final float shadowSize) {
+        super(shadowSize);
+    }
+
+    @Override
+    protected @Nullable StaticEntityModel getAndSetupModelForLayer(@NotNull final MobDeer entity, final float brightness, final float partialTick, final int layer) {
+        final StaticEntityModel model = getModel("main");
+        model.resetBones();
+
+        final BoneTransform neck = model.getTransform("neck");
+        final BoneTransform head = model.getTransform("head");
+        final BoneTransform leg0 = model.getTransform("leg0");
+        final BoneTransform leg1 = model.getTransform("leg1");
+        final BoneTransform leg2 = model.getTransform("leg2");
+        final BoneTransform leg3 = model.getTransform("leg3");
+
+        final float bodyYaw = getBodyYaw(entity, partialTick);
+        final float headYaw = getHeadYaw(entity, partialTick) - bodyYaw;
+        final float headPitch = getHeadPitch(entity, partialTick);
+        final float limbSwing = getLimbSwing(entity, partialTick);
+        final float limbYaw = getLimbYaw(entity, partialTick);
+
+        neck.rotX = headPitch;
+        head.rotY = headYaw;
+        leg0.rotX = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
+        leg1.rotX = MathHelper.cos(limbSwing * 0.6662F + MathHelper.PI) * 1.4F * limbYaw;
+        leg2.rotX = MathHelper.cos(limbSwing * 0.6662F + MathHelper.PI) * 1.4F * limbYaw;
+        leg3.rotX = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
+
+        return model;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java
index e6f234536..f4f239602 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java
@@ -26,7 +26,7 @@ public class MobRendererWolf extends MobRenderer<MobWolf> {
         if (layer == 1) {
             final ArmorMaterial material = entity.getArmorMaterial();
             if (material == null) return null;
-            bindTexture(String.format("/assets/%s/textures/armor/wolf/%s.png", material.identifier.namespace, material.identifier.value));
+            bindTexture(String.format("/assets/%s/textures/armor/wolf/%s.png", material.identifier.namespace(), material.identifier.value()));
             model = getModel("armor");
         } else {
             model = getModel("main");
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java b/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java
index 02809c47e..5974a14e2 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java
@@ -105,7 +105,7 @@ public class FontRendererDefault extends FontRenderer {
                                 break;
                             }
                             case 'r': {
-                                this.currentConfig = Integer.toUnsignedLong(SF.getColor(baseConfig));
+                                this.currentConfig = Integer.toUnsignedLong(SF.getColor(baseConfig)) | (baseConfig & SF.OUTLINE);
                                 break;
                             }
                             case '+': {
@@ -153,12 +153,14 @@ public class FontRendererDefault extends FontRenderer {
         }
     }
 
-    protected double renderCharInternal(@NotNull final Font font, @NotNull final Tessellator tessellator, final char c, final double x, final double y, final double z, final int color, final boolean shadow) {
+    protected double renderCharInternal(@NotNull final Font font, @NotNull final Tessellator tessellator, final char c, final double x, final double y, final double z, final int color, boolean shadow) {
         final int rgb = color & 0xFFFFFF;
         final int shadowRGB = (color & 0xFCFCFC) >> 2; // Divide RGB by 4
         final int a = (color & 0xFF_00_00_00) != 0 ? (color >> 24) & 0xFF : 0xFF;
         tessellator.startDrawingQuads();
 
+        shadow &= !SF.isOutlined(this.currentConfig);
+
         final double px = 1;
         final double px2 = px * 2;
 
@@ -174,6 +176,16 @@ public class FontRendererDefault extends FontRenderer {
                 if (SF.isBold(this.currentConfig)) font.renderChar(tessellator, randomChar, x + px2, y + px, z, SF.isItalic(this.currentConfig));
             }
 
+            if (SF.isOutlined(this.currentConfig)) {
+                tessellator.setColorRGBA_I((rgb & 0xFCFCFC) >> 2, a);
+                final double width = SF.isBold(this.currentConfig) ? 2.05 : 1.05;
+                for (double _x = -1; _x <= width; _x += 1/3d) {
+                    for (double _y = -1; _y <= 1.05; _y += 1/3d) {
+                        font.renderChar(tessellator, randomChar, x + _x, y + _y, z, SF.isItalic(this.currentConfig));
+                    }
+                }
+            }
+
             tessellator.setColorRGBA_I(rgb, a);
             font.renderChar(tessellator, randomChar, x, y, z, SF.isItalic(this.currentConfig));
             if (SF.isBold(this.currentConfig)) {
@@ -188,6 +200,16 @@ public class FontRendererDefault extends FontRenderer {
                 if (SF.isBold(this.currentConfig)) font.renderChar(tessellator, c, x + px2, y + px, z, SF.isItalic(this.currentConfig));
             }
 
+            if (SF.isOutlined(this.currentConfig)) {
+                tessellator.setColorRGBA_I((rgb & 0xFCFCFC) >> 2, a);
+                final double width = SF.isBold(this.currentConfig) ? 2.05 : 1.05;
+                for (double _x = -1; _x <= width; _x += 1/3d) {
+                    for (double _y = -1; _y <= 1.05; _y += 1/3d) {
+                        font.renderChar(tessellator, c, x + _x, y + _y, z, SF.isItalic(this.currentConfig));
+                    }
+                }
+            }
+
             tessellator.setColorRGBA_I(rgb, a);
             shift = font.renderChar(tessellator, c, x, y, z, SF.isItalic(this.currentConfig));
             if (SF.isBold(this.currentConfig)) {
